import sys

def eval(gold_trees, pred_trees):
    ucorr = 0.
    lcorr = 0.
    total = 0.
    ucomplete_match = 0.
    lcomplete_match = 0.

    ucorr_nopunc = 0.
    lcorr_nopunc = 0.
    total_nopunc = 0.
    ucomplete_match_nopunc = 0.
    lcomplete_match_nopunc = 0.

    corr_root = 0.
    total_root = 0.
    start = 0
    end = 0
    for g_tree, p_tree in zip(gold_trees, pred_trees):
        ucm = 1.
        lcm = 1.
        ucm_nopunc = 1.
        lcm_nopunc = 1.
        for g_node, p_node in zip(g_tree, p_tree):
            total += 1
            if g_node[6] == p_node[6]:
                ucorr += 1
                if g_node[7].split(":")[0] == p_node[7].split(":")[0]:
                    lcorr += 1
                else:
                    lcm = 0
            else:
                ucm = 0
                lcm = 0
            
        ucomplete_match += ucm
        lcomplete_match += lcm

    return (ucorr, lcorr, total, ucomplete_match, lcomplete_match)

def read(filepath):
    trees, tree = [], []
    with open(filepath, "r") as f:
        for line in f:
            node = line.split("\t")
            if len(node) == 1:
                trees.append(tree)
                tree = []
            else:
                tree.append(node)
    return trees

def get_scores(gold, pred):
    l_correct = 0.
    u_correct = 0.
    total = 0.
    for g_tree, p_tree in zip(gold, pred):
        assert(len(g_tree) == len(p_tree))
        for g_node, p_node in zip(g_tree, p_tree):
            total += 1
            if g_node[7].split(":")[0] == p_node[7].split(":")[0]:
                u_correct += 1
                if g_node[7] == p_node[7]:
                    l_correct += 1
    print(u_correct)
    print(l_correct)
    print(total)
    uas = u_correct/total * 100
    las = l_correct/total * 100
    return uas, las


if __name__ == "__main__":
    gold_filepath = sys.argv[1]
    pred_filepath = sys.argv[2]
    gold_trees = read(gold_filepath)
    pred_trees = read(pred_filepath)
    print(len(gold_trees))
    uas, las = get_scores(gold_trees, pred_trees)
    print("UAS", format(uas, ".2f"))
    print("LAS", format(las, ".2f"))
    print(eval(gold_trees, pred_trees))
    
