#!/bin/bash
model_dir="models/"
embeddings_dir="word-embeddings/"
treebanks="treebanks/"
logfile="../seqlab-baseline-dev-times-cpu-test.csv"
echo "model,total time 1,parse time 1,total time 2,parse time 2,total time 3,parse time 3,total time 4,parse time 4,total time 5,parse time 5" > $logfile

for treebank_dir in $treebanks/UD_*
do
    treebank=$(basename $treebank_dir)
    embeddings=$(echo "$embeddings_dir$treebank/vectors")
    dev=$(ls $treebank_dir/*test.conllu)
    out_dev=$(basename $dev)
    for n_layers in 2 3 
    do
	for n_nodes in 200 300 400 500 
	do
	    let n=$n_layers
	    let m=$n_nodes+$n_nodes
	    pred=$(echo pred/$n-$m-$out_dev)
	    echo $pred
	    model_name=$(echo "$model_dir$treebank-$n-$m")
	    vocab_name=$(echo "$model_dir$treebank-$n-$m.vocab")
	    echo $model_name $vocab_name
	    times=""
	    for x in 1 2 3 4 5
	    do
		echo $x
		times_new=$(taskset --cpu-list $x python run.py predict --fdata $dev --fpred $pred --model $model_name --vocab $vocab_name \
				    --device -1  --batch-size 128 | grep TIMES | awk '{ print $2 }')
		times="${times},${times_new}"
	    done
	    echo $treebank-$n-$m$times >> $logfile
	done
    done
done
