#!/bin/bash
model_dir="models/"
embeddings_dir="word-embeddings/"
treebanks="treebanks/"
logfile="../training.csv"
energy_logfile="../energy.csv"

for treebank_dir in $treebanks/UD_*
do
    treebank=$(basename $treebank_dir)
    embeddings=$(echo "$embeddings_dir$treebank/vectors")
    train=$(ls $treebank_dir/*train.conllu)
    dev=$(ls $treebank_dir/*dev.conllu)
    for n_layers in 2 3 
    do
	for n_nodes in 200 300 400 500 
	do
	    let n=$n_layers
	    let m=$n_nodes+$n_nodes
	    model_name=$(echo "$model_dir$treebank-$n-$m")
	    if [ -f $model_name ]; then
		continue
	    fi
	    vocab_name=$(echo "$model_dir$treebank-$n-$m.vocab")
	    echo $model_name $vocab_name
	    python run.py train --ftrain $train --fdev $dev --model $model_name --vocab $vocab_name \
		   --n_lstm_nodes $n_nodes --n_lstm_layers $n_layers --device 1 \
		   --log_path $logfile --log_energy $energy_logfile \
		   --fembed $embeddings
	done
    done
done
